<?xml version="1.0" ?>
<launch>
    <arg name="robot_ip" default="172.16.0.3" />
    <arg name="load_gripper" default="false" />
    <arg name="load_dh_gripper" default="false" />
    <arg name="sim" default="false" />
    <arg name="arm_id" default="panda" />
    <arg name="controller" value="torque_Qontrol"/>
    <arg name="rviz" default="true"/>
    <param name="is_sim" value="$(arg sim)"/>
    
    <group ns="$(arg arm_id)">
        <rosparam command="load" file="$(find panda_qontrol)/config/torque.yaml" subst_value="true"/>
        
        <param name="robot_description"
         command="xacro $(find franka_description)/robots/panda_arm.urdf.xacro
                  gazebo:=$(arg sim)
                  hand:=$(arg load_gripper)
                  arm_id:=$(arg arm_id)">
        </param>
        <!-- <include file="$(find setup_description)/launch/setup.launch" >
            <arg name="sim" value="$(arg sim)"/>
            <arg name="load_gripper" value="$(arg load_gripper)" />
            <arg name="load_dh_gripper" value="$(arg load_dh_gripper)" />
        </include> -->
                
        <group unless="$(arg sim)">
            <include file="$(find panda_qontrol)/launch/franka_control.launch" >
                <arg name="robot_ip" value="$(arg robot_ip)" />
                <arg name="load_gripper" value="$(arg load_gripper)" />
                <arg name="arm_id" value="$(arg arm_id)" />
            </include>
            
            <node name="controller_spawner" pkg="controller_manager" type="spawner" respawn="false" output="screen" args="$(arg controller)"/>
            <!-- Error recovery at each startup -->
            <node name="rostopic" pkg="rostopic" type="rostopic" args="pub /panda/franka_control/error_recovery/goal franka_msgs/ErrorRecoveryActionGoal {}"/>
        </group>

        <include file="$(find panda_qontrol)/launch/moveit.launch" >
            <arg name="load_gripper" value="$(arg load_gripper)"/>
            <arg name="load_dh_gripper" value="$(arg load_dh_gripper)" />
            <arg name="arm_id" value="$(arg arm_id)"/>
        </include>
        
        <node if="$(arg rviz)" name="interactive_marker" pkg="moveit_trajectory_interface"  type="interactive_marker.py">
            <param name="state_topic" value="/panda/joint_states" /> 
            <param name="robot_description_param_name" value="/panda/robot_description" /> 
        </node>

        <node  if="$(arg rviz)" name="rviz" pkg="rviz"  type="rviz" args="-d $(find panda_qontrol)/launch/robot.rviz"/>
        
        <include if="$(arg sim)" file="$(find panda_qontrol)/launch/simulation.launch" >
            <arg name="controller" value="$(arg controller)"/>
            <arg name="load_gripper" value="$(arg load_gripper)"/>
            <arg name="load_dh_gripper" value="$(arg load_dh_gripper)" />
            <arg name="arm_id" value="$(arg arm_id)"/>
        </include>
    </group>

</launch>
